<script>
import Vue from 'vue';

export default Vue.extend({
  name: 'CompetitionModal',
  props: {
    lightBackground: {
      type: Boolean,
      required: false,
      default: false,
    },
    visible: {
      type: Boolean,
      required: true,
      default: false,
    },
  },
  mounted() {
    if (this.visible) {
      this.$refs.btnClose.focus();
    }
  },
  methods: {
    close() {
      this.$emit('close');
    },
  },
});
</script>

<template>
  <div
    :class="[
      lightBackground
        ? 'modal__backdrop modal__backdrop--light'
        : 'modal__backdrop',
    ]"
  >
    <div class="modal" role="dialog" tabindex="1">
      <header class="modal__header">
        <slot name="header"></slot>
        <button
          ref="btnClose"
          type="button"
          class="btn btn__close"
          aria-label="close modal"
          @click="close"
        >
          close
          <svg
            width="32"
            height="32"
            viewBox="0 0 32 32"
            fill="none"
            xmlns="http://www.w3.org/2000/svg"
          >
            <path
              d="M19.9515 10.3515C20.4201 9.88284 21.1799 9.88284 21.6485 10.3515C22.1172 10.8201 22.1172 11.5799 21.6485 12.0485L17.6971 16L21.6485 19.9515C22.1172 20.4201 22.1172 21.1799 21.6485 21.6485C21.1799 22.1172 20.4201 22.1172 19.9515 21.6485L16 17.6971L12.0485 21.6485C11.5799 22.1172 10.8201 22.1172 10.3515 21.6485C9.88284 21.1799 9.88284 20.4201 10.3515 19.9515L14.3029 16L10.3515 12.0485C9.88284 11.5799 9.88284 10.8201 10.3515 10.3515C10.8201 9.88284 11.5799 9.88284 12.0485 10.3515L16 14.3029L19.9515 10.3515Z"
              fill="#333333"
            />
          </svg>
        </button>
      </header>
      <section ref="videoSection" class="modal__body">
        <slot name="body"></slot>
      </section>
      <footer class="modal__footer">
        <slot name="footer"></slot>
      </footer>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.modal {
  position: relative;
  background: $color-surface-50;
  display: flex;
  flex-direction: column;
  margin-top: $spacing-64;
  border: 1px solid #e8e7eb;
  box-shadow: 0 16px 50px -16px #d1d0d3;
  border-radius: 8px;
  width: 40vw;
  max-height: 80vh;
  padding: $spacing-16 $spacing-16 $spacing-24 $spacing-32;

  @media (max-width: $breakpoint-lg) {
    min-width: 200px;
    width: 100%;
    max-width: 90vw;
    max-height: 80vh;
    padding: $spacing-16;
  }

  &__backdrop {
    overflow-y: scroll;
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: rgba($color-surface-700, 0.85);
    display: flex;
    justify-content: center;
    align-items: flex-start;
    z-index: 1040;
    &--light {
      background-color: rgba($color-surface-50, 0.75);
    }

    @media (max-width: $breakpoint-md) {
      height: 100%;
    }
  }

  &__header {
    position: relative;
    justify-content: space-between;
    background-color: transparent;
    justify-content: flex-end;
    padding: $spacing-8 0;
    display: flex;
  }

  &__footer {
    padding: $spacing-16;
    display: flex;
  }
  &__body {
    position: relative;
    padding: $spacing-8 $spacing-64 $spacing-8 $spacing-8;
    overflow-y: scroll;

    @media (max-width: $breakpoint-md) {
      overflow: scroll;
    }

    &:deep {
      h3 {
        margin-bottom: $spacing-24;
      }

      .flex {
        justify-content: space-between;
        margin-bottom: $spacing-16;
      }

      .flex p {
        margin-right: $spacing-8;
        display: inline-block;
        width: 60px;
      }

      .description {
        margin-top: 24px;

        p,
        ul,
        ol {
          margin-bottom: $spacing-24;
        }

        ul {
          list-style: disc;
          list-style-position: inside;
          text-indent: -1.25em;
          padding-left: 2em;

          li {
            margin-bottom: $spacing-8;
          }

          li > ul {
            list-style: circle;
            list-style-position: inside;
            padding-left: 1.5em;
            padding-top: $spacing-8;
            padding-bottom: 0;
            margin-bottom: $spacing-8;
          }
        }
      }
    }
  }
}
.btn {
  &__close {
    font-size: 14px;
    line-height: 20px;
    border: none;
    border-radius: 50%;
    cursor: pointer;
    display: flex;
    align-items: center;
    outline: none;
    svg {
      width: 25px;
      height: 25px;
    }
  }
}
</style>
